<?php
if(!defined('IN_SMSOT')) {
	exit;
}

class UC{
	
	var $discuz;
	
	/*
	判断当前系统是否与discuz打通
	*/
	function __construct() {
		global $_S;

		if($_S['dz']['run']){
			loaddiscuz();
			$this->discuz = true;
		}
	}

	/*
	检查密码是否合规
	*/
	function checkpassword($password){
		if(strlen($password)<6){
			showmessage('密码不能小于6位');
		}else{
			return true;
		}
	}

	/*
	检查用户名是否合规
	*/
	function checkusername($username){
		global $_S;
		$len=$this->discuz?16:20;
		if(strlen($username)<3 || strlen($username)>$len){
			showmessage('用户名允许的长度为3-'.$len.'个字节');
		}
		
		if($_S['setting']['sensitive']){
			$_S['setting']['sensitive']=explode(',',$_S['setting']['sensitive']);
			foreach($_S['setting']['sensitive'] as $sensitive){
				if(stristr($username,$sensitive)){
					showmessage('用户名种包含敏感词"'.$sensitive.'"');
				}
			}
		}
		if($_S['setting']['retain']){
			$_S['setting']['retain']=explode(',',$_S['setting']['retain']);
			foreach($_S['setting']['retain'] as $retain){
				if(stristr($username,$retain)){
					showmessage('用户名不能包含"'.$retain.'"');
				}
			}
		}
		return true;
	}
	/*
	过滤用户名中的特殊字符
	*/
	function username($username){
		if(!$username){
			showmessage('请输入用户名');
		}
		preg_match_all('/[\x{4e00}-\x{9fa5}a-zA-Z0-9]/u',$username,$result);
		$username =join('',$result[0]);
		if(!$username){
			showmessage('用户名只能由数字、字母、汉字组成不能包含符号');
		}
		return $username;
	}
	/*
	密码验证
	-1 账号只在discuz存在,smsot尚未注册(返回的member为discuz的用户信息)
	-2 账号只在smsot存在,Discuz尚未注册
	 1 验证成功
	*/
	function verify($user,$password,$type='username'){
		if($type=='username'){
			$user=$this->username($user);
			$field='`username`';
		}else{
			$user=intval($user);
			$field='`uid`';
		}
		if($this->discuz){
			$dzmember=DZ::fetch_first("SELECT * FROM ".DZ::table('members','uc')." WHERE $field='$user'");

			if($dzmember){
				if($dzmember['password']!=md5(md5($password).$dzmember['salt'])){
					//showmessage('密码错误');
					$checksmsotuser=true;
				}else{
					$member=DB::fetch_first("SELECT * FROM ".DB::table('common_user')." WHERE dzuid='$dzmember[uid]'");
					if(!$member){
						$return['code']=-1;
						$return['member']=$dzmember;
					}else{
						$return['code']=1;
						$return['member']=$member;
					}					
				}

			}else{
				$checksmsotuser=true;
				$return['code']=-2;
			}
		}else{
			$checksmsotuser=true;
		}
		if($checksmsotuser){
			$member=DB::fetch_first("SELECT * FROM ".DB::table('common_user')." WHERE $field='$user'");
			if(!$member){
				showmessage('账号不存在');
			}
			if($member['password']!=md5(md5($password).$member['salt'])){
				showmessage('密码错误');
			}
			$return['member']=$member;
			$return['code']=$return['code']?$return['code']:1;
		}
		return $return;
	}
	/*
	退出系统
	*/
	function out(){
    global $_S;
		$user=array('dzuid'=>$_S['member']['dzuid']);
		$this->setuserstate($user);
		setcookies('loginout', '1', 86400);
		setcookies('mini');
	}
	
	/*
	设置用户登录状态
	*/
	function setuserstate($user){
		global $_S;
		$sid=$_S['member']['sid'];
		if($sid){
			$cookies=$sid.'|'.$user['uid'].'|'.$user['username'].'|'.$_S['timestamp'];
			setcookies('cid', $cookies, 2592000);
			if($user['uid']){
				setcookies('auth', authcode("$user[password]\t$user[uid]", 'ENCODE'), 2592000);
				if($this->discuz && $user['dzuid']){
					$this->synchronizationlogin($user['dzuid']);
				}
				upuser(8,$user['uid']);
				upusergroup($user['uid'],$user['groupid']);
				
				//$this->uplog($user['uid']);
			}else{
				setcookies('auth');
				if($this->discuz && $user['dzuid']){
					$this->synchronizationlogin($_S['config']['cookie']['cookiepre']);
				}
			}
			update('common_session',array('uid'=>$user['uid'] ,'username'=>$user['username'],'lv'=>$_S['timestamp'],'invisible'=>'0'),"sid='$sid'");		
		}else{
			setcookies('cid');
		}
	}
	/*
	退出系统
	*/
	function uplog($uid){
    global $_S;
		$ip=get_client_ip();
		update('common_user',array('lastactivity'=>$_S['timestamp'] ,'lastip'=>$ip),"uid='$uid'");
		insert('common_user_log',array('uid'=>$uid ,'dateline'=>$_S['timestamp'] ,'ip'=>$ip));
	}
	/*
	通过短信登录或注册
	*/
	function smsmember(){
		global $_S;

		$s['tel']=trim($_GET['tel']);
		$s['code']=intval($_GET['smscode']);
		$s['lid']=intval($_GET['lid']);

    /*
	  smsot:00,20	
		*/
		if(!checktel($s['tel'])){
			showmessage('请输入正确的手机号码');
		}
	  if(checksmscode($s['lid'],$s['code'])){
			$member=DB::fetch_first("SELECT * FROM ".DB::table('common_user')." WHERE tel='$s[tel]'");
			$res['smsot']=$res['discuz']=0;
			//检测smsot
			//0,1,2
			if($member){
				$res['smsot']=$member['dzuid']?1:2;
			}
			//检测discuz
			//0,1,2
			if($this->discuz && $res['smsot']!=1){
				$dzuser=$this->getdiscuzuser($s['tel'],'tel');
				if($dzuser){
					$user=DB::fetch_first("SELECT * FROM ".DB::table('common_user')." WHERE `dzuid`='$dzuser[uid]'");
					if($user){
						$member=$user;
					}
					$res['discuz']=$user?1:2;
				}
			}
			/*
			1：00（smsot与discuz均为找到符合条件的用户）注册
			2：01（smsot未找到，discuz找到了并且discuz的用户已经关联了smsot）登陆并且设置smsot用户的tel字段
			3：02（smsot未找到，discuz找到了，并且未于smsot关联）插入smsot用户
			4：20（smsot找到了但未关联dzuid，discuz未找到）插入discuz用户并关联
			5：21（smsot找到了但未关联dzuid，discuz也找到了但是已经关联了其他用户）提示用户异常返回dz已经关联的用户UID，和当前smsot的uid，二用户之间要删除一个
			6：22（smsot找到了但未关联dzuid，discuz也找到了并且未关联uid）提示两用户进行关联
			*/
      $rescode=$res['smsot'].$res['discuz'];
     
			switch ($rescode){
				case 00:
	        //注册
					showmessage('请点击下方按钮设置用户名和密码完成注册流程','javascript:regstep(\''.codestr(authcode("tel\t$s[tel]", 'ENCODE')).'\',\'user\');',array('title'=>'最后一步了','must'=>true,'primary'=>'设置用户名'));
					break;  
				case 01:
	        //登录&关联member的tel字段为$dzuser['tel']
					update('common_user',array('tel'=>$dzuser['tel']),"uid='$member[uid]'");
					$login=true;
					break;
				case 02:
				  //插入smsot用户并登陆
					if(DB::fetch_first("SELECT * FROM ".DB::table('common_user')." WHERE username='$dzuser[username]'")){
						$dzuser['username']='Dz_'.strtolower(random(6));
					}
					$member=$this->insertuserformdiscuz($dzuser);
					$login=true;
					break;
				case 20:
				  //插入discuz用户并登陆
					if($this->discuz){
						$username=strlen($member['username'])>16?cutstr($member['username'], 16,''):$member['username'];
						if(DZ::fetch_first("SELECT * FROM ".DZ::table('members','uc')." WHERE username='$username'")){
							$username='Sms_'.strtolower(random(6));
						}
						$dzuid=insertdzuser($member['uid'],$username,$s['password'],$member['tel'],$member['openid'],$member['unionid']);
						update('common_user',array('dzuid'=>$dzuid),"uid='$member[uid]'");						
					}

					$login=true;
					break;
				case 21:
				  //提示用户异常，返回两个用户让用户二选一进行关联，未选中的将被删除,并且登录
					$login=true;
					break;
				case 22:
				  //提示关联并登陆
					update('common_user',array('dzuid'=>$dzuser['uid']),"uid='$member[uid]'");
					$login=true;
					break;
				default:
				  //登录
					$login=true;
				  break;
			}
			//登录
			if($login){
				$this->setuserstate($member);
				showmessage('登录成功','',array('type'=>'toast','fun'=>'SMS.closepage();setTimeout(function(){SMS.clear()},300);')); 
			}
		}
	}
	/*
	写入Smsot用户
	*/
	function insertuser($user,$tables=array()){
		global $_S;
		$uid=insert('common_user',$user);
		if($uid){
			//count
			if($tables['common_user_count']){
				$count=$tables['common_user_count'];
			}
			$count['uid']=$uid;
			//profile
			if($tables['common_user_profile']){
				$profile=$tables['common_user_profile'];
			}
			$profile['uid']=$uid;
			//setting
			if($tables['common_user_setting']){
				$setting=$tables['common_user_setting'];
			}
			$setting['uid']=$uid;
			insert('common_user_count',$count);
			insert('common_user_profile',$profile);
			insert('common_user_setting',$setting);
			
			$_S['user']=$user;
			$_S['user']['uid']=$uid;
			runhookscript('reg');
			return $uid;	
		}
	}
	
	/*
	同步discuz用户到smsot
	*/
	function insertuserformdiscuz($discuzuser,$password=''){
    global $_S;

		$salt = substr(uniqid(rand()), -6);
		$ip=get_client_ip();
		$password = $password?md5(md5($password).$salt):'null';						
		$user=array(
			'formuid'=>0,
			'dzuid'=>$discuzuser['uid'],
			'username'=>$discuzuser['username'],
			'groupid'=>'10',
			'openid'=>$discuzuser['openid'],
			'unionid'=>$discuzuser['unionid'],
			'tel'=>$discuzuser['tel'],
			'salt'=>$salt,
			'password'=>$password,
			'regdate'=>$_S['timestamp'],
			'lastactivity'=>$_S['timestamp'],
			'regip'=>$ip,
			'lastip'=>$ip,
			'state'=>1
		);
		
		$user['uid']=$this->insertuser($user,array('common_user_count'=>array('experience'=>$discuzuser['credits'])));
		if($user['uid']){
			return $user;
		}else{
			showmessage('发生未知错误,错误代码001');
		}
	}
	
	/*
	获取discuz用户信息
	1、wx和tel都有设置并且表名一致
	2、wx和tel都有设置并且不同表
	3、只有wx
	4、只有tel
	*/
	function getdiscuzuser($value,$type='username'){
		global $_S;
		
		$tel_table=$_S['cache']['discuz']['discuz_aliyun']['table'];
		$tel_field=$_S['cache']['discuz']['discuz_aliyun']['field'];
		$tel_uid=$_S['cache']['discuz']['discuz_aliyun']['uid']?$_S['cache']['discuz']['discuz_aliyun']['uid']:'uid';
		
		$wx_table=$_S['cache']['discuz']['discuz_wechat']['table'];
		$wx_field=$_S['cache']['discuz']['discuz_wechat']['field'];
		$wx_unionid=$_S['cache']['discuz']['discuz_wechat']['unionid'];
		$wx_uid=$_S['cache']['discuz']['discuz_wechat']['uid']?$_S['cache']['discuz']['discuz_wechat']['uid']:'uid';
		
		if($type=='username' || $type=='uid'){
			if($_S['cache']['discuz_common']['membersplit'] && !DZ::fetch_first("SELECT * FROM ".DZ::table('common_member')." WHERE `$type`='$value'")){
				$usertable='common_member_archive';
			}else{
				$usertable='common_member';
			}
			$sql['select'] = 'SELECT m.*';
			$sql['from'] ='FROM '.DZ::table($usertable).' m';				
		}

		//1、当wx和tel都有设置并且表名一致
		if($tel_table && $tel_field && $wx_table && $wx_field && $tel_table==$wx_table){

			if($type=='openid' || $type=='unionid' || $type=='tel'){
				$sql['select'] = "SELECT s.`$tel_field` AS `tel`,s.`$wx_field` AS `openid`".($wx_unionid?",s.`$wx_unionid` AS `unionid`":'');
				$sql['from'] ='FROM '.DZ::table($tel_table).' s';			
				if($type=='openid'){
					if(is_array($value) && $value[1]){
						if($wx_unionid){
							$wherearr[] = "(s.`$wx_field` ='$value[0]' OR s.`$wx_unionid` ='$value[1]')";
						}else{
							$wherearr[] = "s.`$wx_field` ='$value[0]'";
						}
					}else{
						$wherearr[] = "s.`$wx_field` ='$value'";
					}
				}elseif($type=='unionid' && $wx_unionid){
					$wherearr[] = "s.`$wx_unionid` ='$value'";
				}elseif($type=='tel'){
					$wherearr[] = "s.`$tel_field` ='$value'";
				}
			}else{
				$sql['select'] .= ",s.`$tel_field` AS `tel`,s.`$wx_field` AS `openid`".($wx_unionid?",s.`$wx_unionid` AS `unionid`":'');
				$sql['left'] .=" LEFT JOIN ".DZ::table($tel_table)." s ON s.`$tel_uid`=m.`uid`";	
			}
		}else{
			$sg=$sc='';
			//如果有设置wx
			if($wx_table && ($wx_field || $wx_unionid)){
				
				if($type=='openid' || $type=='unionid'){
					$sql['select'] = "SELECT w.`$wx_uid` ,w.`$wx_field` AS `openid`".($wx_unionid?",w.`$wx_unionid` AS `unionid`":'');
					$sql['from'] ='FROM '.DZ::table($wx_table).' w';
					if($type=='openid'){
						if(is_array($value) && $value[1]){
							if($wx_unionid){
								$wherearr[] = "(w.`$wx_field` ='$value[0]' OR w.`$wx_unionid` ='$value[1]')";
							}else{
								$wherearr[] = "w.`$wx_field` ='$value[0]'";
							}
						}else{
							$wherearr[] = "w.`$wx_field` ='$value'";
						}
					}elseif($type=='unionid' && $wx_unionid){
						$wherearr[] = "w.`$wx_unionid` ='$value'";
					}
				}elseif($type=='tel'){
					$sg .= ",w.`$wx_field` AS `openid`".($wx_unionid?",w.`$wx_unionid` AS `unionid`":'');
					$sc .="LEFT JOIN ".DZ::table($wx_table)." w ON w.`$wx_uid`=t.`$tel_uid`";	
				}else{
					$sg .= ",w.`$wx_field` AS `openid`".($wx_unionid?",w.`$wx_unionid` AS `unionid`":'');
					$sc .="LEFT JOIN ".DZ::table($wx_table)." w ON w.`$wx_uid`=m.`uid`";	
				}
			}else{
				if($type=='openid' || $type=='unionid'){
					return false;
				}
			}
			//如果有设置tel
			if($tel_table && $tel_field){
				if($type=='tel'){
					$sql['select'] = "SELECT t.`$tel_uid`,t.`$tel_field` AS `tel`";
					$sql['from'] ='FROM '.DZ::table($tel_table).' t';			
					$wherearr[] = "t.`$tel_field` ='$value'";
				}elseif($type=='openid' || $type=='unionid'){
					$sg .= ",t.`$tel_field` AS `tel`";
					$sc .="LEFT JOIN ".DZ::table($tel_table)." t ON t.`$tel_uid`=w.`$wx_uid`";	
				}else{
					$sg .= ",t.`$tel_field` AS `tel`";
					$sc .="LEFT JOIN ".DZ::table($tel_table)." t ON t.`$tel_uid`=m.`uid`";			
				}
			}else{
				if($type=='tel'){
					return false;
				}
			}
		}
		if($type=='username'){
			$wherearr[] = "m.`username` ='$value'";
		}elseif($type=='uid'){
			$wherearr[] = "m.`uid` ='$value'";
		}
		if(!empty($wherearr)) $sql['where'] = 'WHERE '.implode(' AND ', $wherearr);
		$sqlstring = $sql['select'].' '.$sg.' '.$sql['from'].' '.$sql['left'].' '.$sc.' '.$sql['where'];

		$dzuser=DZ::fetch_first($sqlstring);
		
		if($type=='tel' || $type=='openid'){
			$uid=$dzuser[$wx_uid]?$dzuser[$wx_uid]:$dzuser[$tel_uid];
			if($uid){
				$member=DZ::fetch_first("SELECT * FROM ".DZ::table('common_member')." WHERE `uid`='$uid'");
				if(!$member && $_S['cache']['discuz_common']['membersplit']){
					$member=DZ::fetch_first("SELECT * FROM ".DZ::table('common_member_archive')." WHERE `uid`='$uid'");
				}
				if($member){
					$dzuser=array_merge($dzuser,$member);
				}
			}else{
				return false;
			}
		}
		if($dzuser['uid']){
			return $dzuser;
		}else{
			if($dzuser[$tel_field]){
				$v=$dzuser[$tel_field];
				DZ::query("DELETE FROM ".DZ::table($tel_table)." WHERE `$tel_field`='$v'");
			}
			if($dzuser[$wx_field]){
				$v=$dzuser[$wx_field];
				DZ::query("DELETE FROM ".DZ::table($wx_table)." WHERE `$wx_field`='$v'");
			}
		}
	}
	
	/*
	同步discuz登录状态
	*/
	function synchronizationlogin($uid){
		global $_S;
		if($_S['cache']['discuz']['discuz_common']['cookiepre']){
			if(!$_S['cache']['discuz_common']){
				$discuz_common=ROOT.'./data/cache/sys_discuz_common.php';
				if(is_file($discuz_common)){
					include_once $discuz_common;
				}
			}
			if($_S['cache']['discuz_common']['authkey']){
				setcookies('synchronization', authcode("$uid", 'ENCODE',$_S['cache']['discuz_common']['authkey']), 2592000,$_S['cache']['discuz']['discuz_common']['cookiepre']);
			}
		}
	}
	
	/*
	同步账号
	1、账号名
	2、密码
	3、tel
	4、openid、unionid
	*/
	
  function setuser($items,$uid,$dzuid){
		global $_S;
		foreach($items as $k=>$v){
			if(!$v){
				unset($items[$k]);
			}
		}
		$dzuid=$dzuid?$dzuid:$_S['myid'];
		if($this->discuz && $dzuid){
			if($items['username']){
				dzupdate('members',array('username'=>$items['username']),"uid='$dzuid'",false,'uc');
				dzupdate($_S['dz']['membertable'],array('username'=>$items['username']),"uid='$dzuid'");
			}elseif($items['password']){
				dzupdate('members',array('password'=>$items['password'],'salt'=>$_S['member']['salt']),"uid='$dzuid'",false,'uc');
			}elseif($items['tel']){
				$tel_table=$_S['cache']['discuz']['discuz_aliyun']['table'];
				$tel_field=$_S['cache']['discuz']['discuz_aliyun']['field'];
				$tel_uid=$_S['cache']['discuz']['discuz_aliyun']['uid']?$_S['cache']['discuz']['discuz_aliyun']['uid']:'uid';
				if($tel_table && $tel_field){
					if(DZ::fetch_first("SELECT * FROM ".DZ::table($tel_table)." WHERE $tel_uid='$dzuid'")){
						dzupdate($tel_table,array($tel_field=>$items['tel']),"$tel_uid='$dzuid'");
					}else{
						if(in_array($tel_table,array('common_member','common_member_count','common_member_field_forum','common_member_field_home','common_member_profile','common_member_status'))){
							DZ::query("UPDATE ".DZ::table($tel_table)." SET `$tel_field`='$items[tel]' WHERE `uid`='$dzuid'");
						}else{
							dzinsert($tel_table,array($tel_uid=>$dzuid,$tel_field=>$items['tel']));
						}
					}
				}
			}else{
				$wx_table=$_S['cache']['discuz']['discuz_wechat']['table'];
				$wx_field=$_S['cache']['discuz']['discuz_wechat']['field'];
				$wx_unionid=$_S['cache']['discuz']['discuz_wechat']['unionid'];
				$wx_uid=$_S['cache']['discuz']['discuz_wechat']['uid']?$_S['cache']['discuz']['discuz_wechat']['uid']:'uid';

				if($wx_table && ($wx_field || $wx_unionid)){
					if($items['openid'] && $wx_field){
						$ups[$wx_field]=$items['openid'];
					}
					if($items['unionid'] && $wx_unionid){
						$ups[$wx_unionid]=$items['unionid'];
					}
					if($ups){
						if(DZ::fetch_first("SELECT * FROM ".DZ::table($wx_table)." WHERE $wx_uid='$dzuid'")){
							dzupdate($wx_table,$ups,"$wx_uid='$dzuid'");
						}else{
							if(in_array($wx_table,array('common_member','common_member_count','common_member_field_forum','common_member_field_home','common_member_profile','common_member_status'))){
								dzupdate($wx_table,$ups,"uid='$dzuid'");
							}
						}						
					}

				}
			}
		}
		update('common_user',$items,"uid='$uid'");
	}
}


?>